/*-*- mode:c;indent-tabs-mode:nil;c-basic-offset:2;tab-width:8;coding:utf-8 -*-│
│ vi: set et ft=c ts=2 sts=2 sw=2 fenc=utf-8                               :vi │
╞══════════════════════════════════════════════════════════════════════════════╡
│ Copyright 2021 Justine Alexandra Roberts Tunney                              │
│                                                                              │
│ Permission to use, copy, modify, and/or distribute this software for         │
│ any purpose with or without fee is hereby granted, provided that the         │
│ above copyright notice and this permission notice appear in all copies.      │
│                                                                              │
│ THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL                │
│ WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED                │
│ WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE             │
│ AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL         │
│ DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR        │
│ PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER               │
│ TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR             │
│ PERFORMANCE OF THIS SOFTWARE.                                                │
╚─────────────────────────────────────────────────────────────────────────────*/
#include "libc/str/str.h"
#include "libc/testlib/ezbench.h"
#include "libc/testlib/testlib.h"

TEST(strcasecmp, test) {
  EXPECT_EQ(0, strcasecmp("HELLO", "hello"));
  EXPECT_EQ(0, strcasecmp("HELLOHELLOHELLOHELLOHELLOHELLO",
                          "hellohellohellohellohellohello"));
  EXPECT_EQ(-17, strcasecmp("HELLO", "yello"));
  EXPECT_EQ(-17, strcasecmp("HELLO", "YELLO"));
  EXPECT_EQ(+17, strcasecmp("yello", "HELLO"));
  EXPECT_EQ(+17, strcasecmp("YELLO", "HELLO"));
}

BENCH(strcasecmp, bench) {
  EZBENCH2("strcasecmp 16 eq (same)", donothing,
           __expropriate(strcasecmp(__veil("r", "abcdefghijklmnop"),
                                    "abcdefghijklmnop")));
  EZBENCH2("strcasecmp 16 eq (evil)", donothing,
           __expropriate(strcasecmp(__veil("r", "abcdefghijklmnop"),
                                    "ABCDEFGHIJKLMNOP")));
}
